# -*- coding: utf-8 -*-
"""LSTM using keras on TRADE day data_1123

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/19AYT_kMTR_fYU4qqMC_WlxS0hUtyZ600
"""

#! pip install yfinance
import math
#import yfinance as yf
import numpy as np
import pandas as pd
from sklearn.preprocessing import MinMaxScaler 
import matplotlib.pyplot as plt
import tensorflow as tf
from tensorflow import keras
from tensorflow.keras import layers

"""
"""

from google.colab import files
uploaded = files.upload()

#reading gz file and converting into csv dataframe
## Merge Multiple 1M Rows CSV files
import os
import pandas as pd

# 1. defines path to csv files
path = "/content/"

# 2. creates list with files to merge based on name convention
file_list = [path + f for f in os.listdir(path) if f.startswith('2022')]

# 3. creates empty list to include the content of each file converted to pandas DF
csv_list = []
 
# 4. reads each (sorted) file in file_list, converts it to pandas DF and appends it to the csv_list
for file in sorted(file_list):
    csv_list.append(pd.read_csv(file).assign(File_Name = os.path.basename(file)))

# 5. merges single pandas DFs into a single DF, index is refreshed 
csv_merged = pd.concat(csv_list, ignore_index=True)

# 6. Single DF is saved to the path in CSV format, without index column
csv_merged.to_csv(path + 'trade_data.csv', index=False)

#reading gz file and converting into csv dataframe
import gc
import pandas as pd
df = pd.read_csv('trade_data.csv')
df.info()
df.head()

df= df.sort_values(by = ['COLLECTION_TIME'],ascending = True )

#converting collection_time variable from object to datetime
df['COLLECTION_TIME'] = pd.to_datetime(df['COLLECTION_TIME'])

df['time_difference'] = df['COLLECTION_TIME'].diff()

#checking data_types
df.dtypes

df.tail()

#checking for symbols 
df['SYMBOL'].unique()

#selecting only  'SPY' symbol. You dont need to run this step if there is only one symbol
df_filter = df[df['SYMBOL']=='SPY']

#copying data from df_filter to df1
df1 = df_filter.set_index("COLLECTION_TIME")

#plotting the price vs time graph
import matplotlib.pyplot as plt
plt.figure(figsize=(15, 8))
plt.title('Stock Prices History')
plt.plot(df1['PRICE'])
plt.xlabel('COLLECTION_TIME')
plt.ylabel('Prices ($)')
plt.legend(loc='best')
plt.show()

#Generatng X and y datasets for train and test
df3 = df1.loc[:,('PRICE','SIZE')]
X = df1.loc[:,('PRICE')]
y = df1.loc[:,('PRICE')]
X =X.values.reshape(-1,1)
y =y.values.reshape(-1,1)

#scaling X and y values to 0 and 1 using scaler
from sklearn.preprocessing import StandardScaler, MinMaxScaler
min_scaler = MinMaxScaler()
X_ss = min_scaler.fit_transform(X)
y_ss = min_scaler.fit_transform(y)

#generating training dataset
import math
train_len = int(math.ceil(len(X_ss)* 0.7))
X_train = []
y_train = []

X_train = X_ss[:train_len]
y_train = y_ss[:train_len]


X_train = np.array(X_train)
y_train = np.array(y_train).reshape(-1,1)
print(X_train.shape,y_train.shape)

#converting training dataset from 2d to 3d
X_train = np.reshape(X_train, (X_train.shape[0], X_train.shape[1], 1))
print(X_train.shape)

#generating test dataset
X_test = []
X_test = X_ss[train_len:]
X_test = np.array(X_test) 
#X_test = np.reshape(X_test, (X_test.shape[0], X_test.shape[1],1))
print(X_test.shape)

#generating y test data
y_test = y[train_len:]
y_test = np.array(y_test)

#LSTM model 
model = keras.Sequential()
model.add(layers.LSTM(128, return_sequences=True, input_shape=(X_train.shape[1], 1)))
model.add(layers.LSTM(128, return_sequences=False))
model.add(layers.Dense(32,activation='relu'))
model.add(layers.Dense(1,activation='sigmoid'))
model.summary()

#compiling the model
#model.compile(loss=['binary_crossentropy'] , optimizer='adam', metrics=['accuracy'])
model.compile(optimizer='adam', loss='mean_squared_error',metrics=['mean_absolute_error'])

#earling stopping condition
from keras.callbacks import EarlyStopping
es = EarlyStopping(monitor='loss',mode='min', verbose=1, patience=5) 
#fitting the X_train to y_train
k = model.fit(X_train, y_train, epochs=200, batch_size=32,  callbacks=[es])

#predicting using X_test and calculating RMSE
predictions = model.predict(X_test)
predictions_transformed = min_scaler.inverse_transform(predictions)
rmse = np.sqrt(np.mean(predictions_transformed - y_test)**2)
rmse

#plotting the losses
plt.plot(k.history['loss'],'b', label='training loss')
plt.title('Training  loss')
plt.xlabel('No. of Epochs')
plt.ylabel('Loss')
plt.legend()
plt.show()

#preparing the validation dataset
df4 = df3
validation = df4[train_len:]
train = df4['PRICE']
validation['Predictions_i'] = predictions
validation['Predictions'] = predictions_transformed
validation.head()

#Plottting the train 
plt.figure(figsize=(16,8))
plt.title('Model')
plt.xlabel('Date')
plt.ylabel('Close Price USD ($)')
plt.plot(train)
plt.plot(validation[['Predictions','PRICE']])
plt.legend(['Train', 'Val', 'Predictions'], loc='lower right')
plt.show()

#trading strategy for buy and sell 
#df5['predictions'] = predictions
validation['signal'] = np.where(validation['Predictions_i']>np.mean(validation['Predictions_i']) ,1,0)
validation['trade1'] = validation['signal'] - validation['signal'].shift(1)#classification

np.mean(validation['Predictions_i'])

#checking the signal count
validation['signal'].value_counts()

#entry and exit the trade based on entry. Buy if extry = 1 and sell entry =-1
validation['entry'] = validation['signal'].diff()
validation['entry'].value_counts()

validation.loc[(validation['entry'] == 1),'trade']=1 #long
validation.loc[(validation['entry'] == 0),'trade']=0
validation.loc[(validation['entry'] == -1),'trade']=-1# short

validation['return'] = validation['PRICE'].pct_change().shift(-1)
validation['pnl'] = validation['return']*validation['trade']*validation['SIZE']
validation['pnl'].mean()

#looking at snapshot based on details
plt.rcParams['figure.figsize'] = 12, 6
plt.grid(True, alpha = .3)
plt.plot(train,label = "training_data")
plt.plot(validation['PRICE'], label = 'Actual_price')
plt.plot(validation['Predictions'], label = 'Predicted_price')
plt.plot(validation.loc[validation.entry == 1].index, validation['Predictions'][validation.entry == 1], '^', color = 'b', markersize = 8,label='buy')
plt.plot(validation.loc[validation.entry == -1].index, validation['Predictions'][validation.entry == -1], 'v',color = 'r', markersize = 8,label='sell')
plt.legend()



"""#forecasting strategy:

"""

# time_gap = 2 sec ; So in 1 min = 30 timesteps; 
look_back = 1800 #half an hour
num_prediction = 300 #predict for 10 mins
def predicted_price(num_prediction, model):
    prediction_list = X_ss[-look_back:]
    
    for _ in range(num_prediction):
        x = prediction_list[-look_back:]
        x = x.reshape(look_back,1,-1)
        out = model.predict(x)[0][0]
        prediction_list = np.append(prediction_list, out)
    prediction_list = prediction_list[look_back-1:]
        
    return prediction_list

forecast_price_feature = predicted_price(num_prediction,model)
forecast_price_scaled = min_scaler.inverse_transform(forecast_price_feature.reshape(-1,1))

#prediciting future time
def predict_time(num_prediction):
    last_time = df_filter['COLLECTION_TIME'].values[-1]
    prediction_time = pd.date_range(last_time, periods=num_prediction+1,freq = '2S').tolist()
    return prediction_time
forecast_time = predict_time(num_prediction)

#converting the variables into pandas
forecasted_price = pd.DataFrame(forecast_price_scaled)
forecasted_time = pd.DataFrame(forecast_time)
forecast_price_feature = pd.DataFrame(forecast_price_feature)

#combining dataset of forecasted time and date
forecasted_data = pd.concat([forecasted_time,forecasted_price,forecast_price_feature],axis = "columns")
forecasted_data.columns = ['Forecasted_time','Forecasted_price','forecast_price_feature']
#forecasted_data.tail()

#plot the graph
plt.figure(figsize=(16,8))
validation1 = validation.reset_index()
plt.plot(forecasted_data['Forecasted_time'],forecasted_data['Forecasted_price'])
plt.plot(validation1['COLLECTION_TIME'],validation1['Predictions'])
#plt.plot(train[-500:])
plt.legend(['forecasted_price', 'validated_price'], loc='lower right')

plt.show()

#creating startegy  dataset for strategy implementation of buy and sell
validation = validation.reset_index()
collection_time = pd.concat([validation['COLLECTION_TIME'],forecasted_data['Forecasted_time']],axis = 0)
price = pd.concat([validation['Predictions'],forecasted_data['Forecasted_price']],axis = 0)
price_feature = pd.concat([validation['Predictions_i'],forecasted_data['forecast_price_feature']],axis = 0)
strat_data = pd.concat([collection_time,price,price_feature],axis=1)
strat_data.columns = ['COLLECTION_TIME','price','price_feature']

strat_data = strat_data.reset_index()
forecasted_data['Forecasted_time'][1]

#the flag for showing that price is forecasted
strat_data['forecasted_flag'] =strat_data['COLLECTION_TIME'].apply(lambda x: 1 if x >= forecasted_data['Forecasted_time'][1] else 0)
strat_data['forecasted_flag'].value_counts()

#signal generation  
strat_data['signal'] = np.where(strat_data['price_feature']>np.mean(strat_data['price_feature']) ,1,0)
strat_data['signal'].value_counts()

#entry and exit the trade based on entry. Buy if extry = 1 and sell entry =-1
strat_data['entry'] =strat_data['signal'].diff()
strat_data['entry'].value_counts()

strat_data.loc[(strat_data['entry'] == 1),'trade']=1 #long
strat_data.loc[(strat_data['entry'] == 0),'trade']=0
strat_data.loc[(strat_data['entry'] == -1),'trade']=-1# short

strat_data['return'] = strat_data['price'].pct_change().shift(-1)
strat_data['pnl'] = strat_data['return']*strat_data['trade']
strat_data['pnl'].mean()

plt.rcParams['figure.figsize'] = 12, 6
plt.grid(True, alpha = .3)
plt.plot(strat_data['price'], label = 'forecasted_price')
plt.plot(validation['Predictions'][-500:], label = 'Validation_price')
plt.plot(strat_data.loc[strat_data.entry == 1].index, strat_data['price'][strat_data.entry == 1], '^', color = 'b', markersize = 8,label='buy')
plt.plot(strat_data.loc[strat_data.entry == -1].index, strat_data['price'][strat_data.entry == -1], 'v',color = 'r', markersize = 8,label='sell')
plt.legend()

